diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index dea01e7025..a8caa9bf9d 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,13 @@
 2017-01-03  John Baldwin  <jhb@FreeBSD.org>
 
+	* Makefile.in (ALLDEPFILES): Add mips-fbsd-nat.c.
+	* NEWS: Mention new FreeBSD/mips native configuration.
+	* config/mips/fbsd.mh: New file.
+	* configure.host: Add mips*-*-freebsd*.
+	* mips-fbsd-nat.c: New file.
+
+2017-01-03  John Baldwin  <jhb@FreeBSD.org>
+
 	* Makefile.in (ALL_TARGET_OBS): Add mips-fbsd-tdep.o.
 	(ALLDEPFILES): Add mips-fbsd-tdep.c.
 	* NEWS: Mention new FreeBSD/mips target.
diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index f20b97347a..f5f15c23c1 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -2541,6 +2541,7 @@ ALLDEPFILES = \
 	microblaze-linux-tdep.c \
 	microblaze-tdep.c \
 	mingw-hdep.c \
+	mips-fbsd-nat.c \
 	mips-fbsd-tdep.c \
 	mips-linux-nat.c \
 	mips-linux-tdep.c \
diff --git a/gdb/NEWS b/gdb/NEWS
index f7fe9aeb76..b9768159cd 100644
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -47,6 +47,11 @@
      end
    end
 
+* New native configurations
+
+FreeBSD/mips			mips*-*-freebsd
+
+
 * New targets
 
 Synopsys ARC			arc*-*-elf32
diff --git a/gdb/config/mips/fbsd.mh b/gdb/config/mips/fbsd.mh
new file mode 100644
index 0000000000..f433347a20
--- /dev/null
+++ b/gdb/config/mips/fbsd.mh
@@ -0,0 +1,3 @@
+# Host: FreeBSD/mips
+NATDEPFILES= fork-child.o inf-ptrace.o fbsd-nat.o mips-fbsd-nat.o
+HAVE_NATIVE_GCORE_HOST = 1
diff --git a/gdb/configure.host b/gdb/configure.host
index ef265ebe29..c45f61dbba 100644
--- a/gdb/configure.host
+++ b/gdb/configure.host
@@ -129,6 +129,7 @@ m88*-*-openbsd*)	gdb_host=obsd ;;
 mips*-*-linux*)		gdb_host=linux ;;
 mips*-*-netbsd* | mips*-*-knetbsd*-gnu)
 			gdb_host=nbsd ;;
+mips*-*-freebsd*)	gdb_host=fbsd ;;
 mips64*-*-openbsd*)	gdb_host=obsd64 ;;
 
 powerpc-*-aix* | rs6000-*-* | powerpc64-*-aix*)
diff --git a/gdb/mips-fbsd-nat.c b/gdb/mips-fbsd-nat.c
new file mode 100644
index 0000000000..fed21a8a98
--- /dev/null
+++ b/gdb/mips-fbsd-nat.c
@@ -0,0 +1,136 @@
+/* Native-dependent code for FreeBSD/mips.
+
+   Copyright (C) 2016 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#include "inferior.h"
+#include "regcache.h"
+#include "target.h"
+
+#include <sys/types.h>
+#include <sys/ptrace.h>
+#include <machine/reg.h>
+
+#include "fbsd-nat.h"
+#include "mips-tdep.h"
+#include "mips-fbsd-tdep.h"
+#include "inf-ptrace.h"
+
+/* Determine if PT_GETREGS fetches this register.  */
+
+static bool
+getregs_supplies (struct gdbarch *gdbarch, int regnum)
+{
+  return (regnum >= MIPS_ZERO_REGNUM
+	  && regnum <= gdbarch_pc_regnum (gdbarch));
+}
+
+/* Fetch register REGNUM from the inferior.  If REGNUM is -1, do this
+   for all registers.  */
+
+static void
+mips_fbsd_fetch_inferior_registers (struct target_ops *ops,
+				    struct regcache *regcache, int regnum)
+{
+  struct gdbarch *gdbarch = get_regcache_arch (regcache);
+  if (regnum == -1 || getregs_supplies (gdbarch, regnum))
+    {
+      struct reg regs;
+
+      if (ptrace (PT_GETREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't get registers"));
+
+      mips_fbsd_supply_gregs (regcache, regnum, &regs, sizeof (register_t));
+      if (regnum != -1)
+	return;
+    }
+
+  if (regnum == -1
+      || regnum >= gdbarch_fp0_regnum (get_regcache_arch (regcache)))
+    {
+      struct fpreg fpregs;
+
+      if (ptrace (PT_GETFPREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &fpregs, 0) == -1)
+	perror_with_name (_("Couldn't get floating point status"));
+
+      mips_fbsd_supply_fpregs (regcache, regnum, &fpregs,
+			       sizeof (f_register_t));
+    }
+}
+
+/* Store register REGNUM back into the inferior.  If REGNUM is -1, do
+   this for all registers.  */
+
+static void
+mips_fbsd_store_inferior_registers (struct target_ops *ops,
+				    struct regcache *regcache, int regnum)
+{
+  struct gdbarch *gdbarch = get_regcache_arch (regcache);
+  if (regnum == -1 || getregs_supplies (gdbarch, regnum))
+    {
+      struct reg regs;
+
+      if (ptrace (PT_GETREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't get registers"));
+
+      mips_fbsd_collect_gregs (regcache, regnum, (char *) &regs,
+			       sizeof (register_t));
+
+      if (ptrace (PT_SETREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &regs, 0) == -1)
+	perror_with_name (_("Couldn't write registers"));
+
+      if (regnum != -1)
+	return;
+    }
+
+  if (regnum == -1
+      || regnum >= gdbarch_fp0_regnum (get_regcache_arch (regcache)))
+    {
+      struct fpreg fpregs;
+
+      if (ptrace (PT_GETFPREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &fpregs, 0) == -1)
+	perror_with_name (_("Couldn't get floating point status"));
+
+      mips_fbsd_collect_fpregs (regcache, regnum, (char *) &fpregs,
+				sizeof (f_register_t));
+
+      if (ptrace (PT_SETFPREGS, get_ptrace_pid (inferior_ptid),
+		  (PTRACE_TYPE_ARG3) &fpregs, 0) == -1)
+	perror_with_name (_("Couldn't write floating point status"));
+    }
+}
+
+
+/* Provide a prototype to silence -Wmissing-prototypes.  */
+void _initialize_mips_fbsd_nat (void);
+
+void
+_initialize_mips_fbsd_nat (void)
+{
+  struct target_ops *t;
+
+  t = inf_ptrace_target ();
+  t->to_fetch_registers = mips_fbsd_fetch_inferior_registers;
+  t->to_store_registers = mips_fbsd_store_inferior_registers;
+  fbsd_nat_add_target (t);
+}